/** Le istanze di questa classe sono dei prismi con un peso 
 *  espresso in grammi.
 *  
 * @author Paolo Boldi
 *
 */
public class Scatola extends Prisma {
	/** Il peso in grammi di questa scatola. */
	private double peso;
	
	// COSTRUTTORI
	public Scatola(double x, double y, double z, double peso) {
		super(x, y, z);
		this.peso = peso;
	}
	
	public Scatola(double latoBase, double altezza, double peso) {
		super(latoBase, altezza);
		this.peso = peso;
	}
	
	public Scatola(double lato, double peso) {
		this(lato, lato, peso);
	}
	
	
	// METODI OVERRIDDEN
	@Override
	public String toString() {
		return super.toString() + " cm. (peso=" + peso + "g.)";
	}
	
	@Override
	public boolean equals(Object o) {
		if (o instanceof Scatola) {
			Scatola s = (Scatola)o;
			return super.equals(s) && peso == s.peso;
		} else
			return false;	
	}
	
	// METODI NUOVI
	public double peso() {
		return peso;
	}
	
	public double pesoSpecifico() {
		return this.peso / this.volume();
	}
	
	public boolean galleggia() {
		return pesoSpecifico() < 1.0;
	}

}



